Page MenuHomePhabricator

Add a link to preferences within the Reply and New Discussion Tools
Closed, ResolvedPublic

Description

This task is about introducing an affordance of some kind within the New Discussion and Reply Tools that will take people to the location within #Special:Preferences that enables them to adjust the behavior of these two tools.

User stories

  • As someone who is wanting to use the interface and worfklow for starting new discussions that I am used to, I want to know how to disable the New Discussion Tool, so that I can regain access to the section=new experience I am used to.
  • As someone who is no longer wanting to see [ reply ] links on the talk pages I am viewing, I want to know how to disable the Reply Tool, so that I can continuing seeing and using talk pages in the state I am used to.

Mockups

TBD

Approach

@matmarex suggested adding a link in the footer, next to "Share feedback about this feature", that would link directly to the "Discussion pages" section of preferences.

Requirements

The below describes what @matmarex first suggested in T291002#7352903 just using different words:

  • For people who are logged in, a link is added beneath the REPLY TOOL'S and the NEW DISCUSSION TOOL'S Advanced shelf that, when clicked, takes people to the Discussion pages heading within Special:Preferences (read: they should be taken to the #mw-prefsection-editing-discussion section)
  • Tracking should be added so that we can answer the following questions: We will address logging in T292044.
    • "How many individual people are clicking the setting link within the Reply Tool?"
    • "How many individual people are clicking the setting link within the New Discussion Tool?"

Done

  • Mockups that fulfill the ===User stories and satisfy the ===Requirements are posted to the ===Mockups section
  • The ===Mockups are implemented

Event Timeline

ppelberg renamed this task from Link to preferences (to disable the tool) in reply tool (new topic tool too?) to Add a link to preferences within the Reply and New Discussion Tools.Sep 18 2021, 1:05 AM
ppelberg updated the task description. (Show Details)
ppelberg updated the task description. (Show Details)

You can link directly to the section in question: Special:Preferences#mw-prefsection-editing-discussion. I don’t think highlighting the section is possible right know, but with this direct link, it may not be worth implementing either.

It would be easy to visually highlight the "Discussion pages" heading with a blueish background or something. (It would be trickier to highlight individual options, the current HTML structure doesn't make that possible.)

Change 722573 had a related patch set uploaded (by Bartosz Dziewoński; author: Bartosz Dziewoński):

[mediawiki/extensions/DiscussionTools@master] Add a link to preferences within the Reply and New Discussion Tools

https://gerrit.wikimedia.org/r/722573

It would be easy to visually highlight the "Discussion pages" heading with a blueish background or something. (It would be trickier to highlight individual options, the current HTML structure doesn't make that possible.)

@matmarex, I've made three updates to the ===Requirements section based on the information you shared above:

  • ADDED a requirement that the Special:Preferences#mw-prefsection-editing-discussion group be visually distinguished in some way
  • ADDED a requirement that this "visual distinguishing" only happen the first time someone follows a links from either tool
  • ADDED a requirement that this "visual distinguishing" fade after some fixed amount of time or action

I think that's a bunch of new-functionality requested for the core Special:Preferences page? (Linking to specific subsections, and adding some sort of first-run experience for said links.)

  • ADDED a requirement that the Special:Preferences#mw-prefsection-editing-discussion group be visually distinguished in some way

Okay. If no one proposes a better idea, I'm going to add a blue highlight to the heading (inspired by the highlight when clicking a reference).

Inspiration
image.png (2×3 px, 1 MB)
Mockup
image.png (2×3 px, 379 KB)
  • ADDED a requirement that this "visual distinguishing" only happen the first time someone follows a links from either tool

I'm not sure about this. That means we'd have to record it (in a hidden preference or something) when someone follows the link. We could do it, but it seems unnecessary to me. It seems more intuitive to make it behave in the same way every time.

  • ADDED a requirement that this "visual distinguishing" fade after some fixed amount of time or action

I'm not sure about this. It seems unusual to me, I think we usually use fade-out for things like success messages – e.g. the messages that appear when you add a page to your watchlist, or save your preferences, or post a reply. We don't usually use them when trying to draw the user's attention for some other reason.

I also agree about keeping it the same every time. (And avoiding extra storage.)

Change 723302 had a related patch set uploaded (by Bartosz Dziewoński; author: Bartosz Dziewoński):

[mediawiki/core@master] Highlight section header when linking to a section on Special:Preferences

https://gerrit.wikimedia.org/r/723302

Change 723303 had a related patch set uploaded (by Bartosz Dziewoński; author: Bartosz Dziewoński):

[mediawiki/core@master] Work around a Chrome bug with :target selector and Special:Preferences tabs

https://gerrit.wikimedia.org/r/723303

This should have been a five-minute thing, but I discovered a Chrome bug where the :target selector (used to style things when you link to them) doesn't work sometimes, and the way the prefereneces tabs are created triggers it. Reported upstream as https://bugs.chromium.org/p/chromium/issues/detail?id=1252507.

Test wiki created on Patch Demo by PPelberg (WMF) using patch(es) linked to this task:

https://patchdemo.wmflabs.org/wikis/08327aaba3/w/

Test wiki created on Patch Demo by PPelberg (WMF) using patch(es) linked to this task:

https://patchdemo.wmflabs.org/wikis/fb0f202878/w/

Oh, the link probably shouldn't appear when you're logged out, since you can't change your preferences.

Oh, the link probably shouldn't appear when you're logged out, since you can't change your preferences.

Good spot; I've updated the ===Requirements in the task description accordingly.

I've also updated the requirement about where the [[Special:Preferences#mw-prefsection-editing-discussionPreferences|Preferences]] link should appear within the two tools: beneath the Advanced shelf – which you've implemented – as opposed to within it as I had written previously.

Regarding T291002#7372992 and the way the highlight in Special:Preferences#mw-prefsection-editing-discussionPreferences [i] behaves...

@matmarex, the changes you've implemented [ii] seem like they will help people to more easily identify the settings that are associated with the tool whose behavior they are wanting to change.

With this said, the more "permanent" nature of these changes (e.g. showing on every click as opposed to the first one, not fading, etc.) is leading me to see this as a bigger change and perhaps one that should be considered for Special:Preferences as a whole.

As such, to start I am thinking we should:

  1. Exclude all of the highlight-related changes from this initial change
  2. File a new ticket for introducing the highlight changes within Special:Preferences as a whole
  3. Consider prioritizing work on the to-be-filed ticket mentioned in "2." if/when people report having difficulty finding the settings associated with the New Discussion and/or Reply Tool.

...if any of the above seems problematic to you, please let me know.


i. Visual showing the highlight in preferencesii. Highlight behavior
Screen Shot 2021-09-27 at 10.45.56 AM.png (812×1 px, 172 KB)
1. Only the Discussion pages heading is highlighted [as opposed to the entire settings "group"), 2. Discussion pages is highlighted every time someone clicks the [[Special:Preferences#mw-prefsection-editing-discussionPreferences|Preferences]] link from within the New Discussion and Reply Tools, and 3. The highlight is shown on the page as long as someone is viewing it [as opposed to it being removed after some amount of time or action being taken]]

The patch does already implement it for the whole of Special:Preferences -- it's not something specific to this section.

DLynch added a project: Editing QA.

There should now be a link to preferences. The highlight patch hasn't been merged because Peter wants to talk about it more.

Change 722573 merged by jenkins-bot:

[mediawiki/extensions/DiscussionTools@master] Add a link to preferences within the Reply and New Discussion Tools

https://gerrit.wikimedia.org/r/722573

There should now be a link to preferences. The highlight patch hasn't been merged because Peter wants to talk about it more.

@DLynch/@ppelberg: Is that patch going to be merged as part of this ticket, or is there a separate ticket filed for that?

There should now be a link to preferences. The highlight patch hasn't been merged because Peter wants to talk about it more.

@DLynch/@ppelberg: Is that patch going to be merged as part of this ticket, or is there a separate ticket filed for that?

Good question, @Ryasmeen. We'll consider this in a separate ticket: T292033.

I've updated the task description's ===Requirements section to reflect the revised scope of this task.

There should now be a link to preferences. The highlight patch hasn't been merged because Peter wants to talk about it more.

@DLynch/@ppelberg: Is that patch going to be merged as part of this ticket, or is there a separate ticket filed for that?

Good question, @Ryasmeen. We'll consider this in a separate ticket: T292033.

I've updated the task description's ===Requirements section to reflect the revised scope of this task.

Thanks @ppelberg, assuming that the tracking part will also be covered in a separate task after we implement the instrumentation, I am moving this to Sign Off.

There should now be a link to preferences. The highlight patch hasn't been merged because Peter wants to talk about it more.

@DLynch/@ppelberg: Is that patch going to be merged as part of this ticket, or is there a separate ticket filed for that?

Good question, @Ryasmeen. We'll consider this in a separate ticket: T292033.

I've updated the task description's ===Requirements section to reflect the revised scope of this task.

Thanks @ppelberg, assuming that the tracking part will also be covered in a separate task after we implement the instrumentation, I am moving this to Sign Off.

I'm glad you drew attention to this bit, @Ryasmeen; we'll revisit the logging in T292044.

ppelberg claimed this task.
ppelberg updated the task description. (Show Details)

Drive-by comment from Design Systems person and reviewer of the patch:
I like the proposed change by @matmarex and agree with @ppelberg on the generalization.

  1. Wonder if the highlight needs to be persistent or could fade out after (f.e.) 3s?
  2. The highlight currently uses an Accent color, which we try to limit for interactive elements. Highlight should rather use a Yellow, like Yellow90. This would only work with a fade out though.

Regarding T291002#7372992 and the way the highlight in Special:Preferences#mw-prefsection-editing-discussionPreferences [i] behaves...

@matmarex, the changes you've implemented [ii] seem like they will help people to more easily identify the settings that are associated with the tool whose behavior they are wanting to change.

With this said, the more "permanent" nature of these changes (e.g. showing on every click as opposed to the first one, not fading, etc.) is leading me to see this as a bigger change and perhaps one that should be considered for Special:Preferences as a whole.

As such, to start I am thinking we should:

  1. Exclude all of the highlight-related changes from this initial change
  2. File a new ticket for introducing the highlight changes within Special:Preferences as a whole
  3. Consider prioritizing work on the to-be-filed ticket mentioned in "2." if/when people report having difficulty finding the settings associated with the New Discussion and/or Reply Tool.

...if any of the above seems problematic to you, please let me know.


i. Visual showing the highlight in preferencesii. Highlight behavior
Screen Shot 2021-09-27 at 10.45.56 AM.png (812×1 px, 172 KB)
1. Only the Discussion pages heading is highlighted [as opposed to the entire settings "group"), 2. Discussion pages is highlighted every time someone clicks the [[Special:Preferences#mw-prefsection-editing-discussionPreferences|Preferences]] link from within the New Discussion and Reply Tools, and 3. The highlight is shown on the page as long as someone is viewing it [as opposed to it being removed after some amount of time or action being taken]]

Change 724788 had a related patch set uploaded (by Bartosz Dziewoński; author: Bartosz Dziewoński):

[mediawiki/extensions/DiscussionTools@wmf/1.38.0-wmf.1] Add a link to preferences within the Reply and New Discussion Tools

https://gerrit.wikimedia.org/r/724788

Change 724789 had a related patch set uploaded (by Bartosz Dziewoński; author: Bartosz Dziewoński):

[mediawiki/extensions/DiscussionTools@wmf/1.38.0-wmf.2] Add a link to preferences within the Reply and New Discussion Tools

https://gerrit.wikimedia.org/r/724789

Change 724788 merged by jenkins-bot:

[mediawiki/extensions/DiscussionTools@wmf/1.38.0-wmf.1] Add a link to preferences within the Reply and New Discussion Tools

https://gerrit.wikimedia.org/r/724788

Change 724789 merged by jenkins-bot:

[mediawiki/extensions/DiscussionTools@wmf/1.38.0-wmf.2] Add a link to preferences within the Reply and New Discussion Tools

https://gerrit.wikimedia.org/r/724789

Mentioned in SAL (#wikimedia-operations) [2021-09-30T11:30:21Z] <kartik@deploy1002> Synchronized php-1.38.0-wmf.1/extensions/DiscussionTools: Backport: [[gerrit:724788|Add a link to preferences within the Reply and New Discussion Tools (T291002)]] (duration: 01m 09s)

Mentioned in SAL (#wikimedia-operations) [2021-09-30T11:35:51Z] <kartik@deploy1002> Synchronized php-1.38.0-wmf.2/extensions/DiscussionTools: Backport: [[gerrit:724789|Add a link to preferences within the Reply and New Discussion Tools (T291002)]] (duration: 01m 08s)